"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _neoBlockchainCore = require("neo-blockchain-core");

var _NetworkAddress = _interopRequireDefault(require("./NetworkAddress"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class AddrPayload {
  constructor({
    addresses
  }) {
    Object.defineProperty(this, "addresses", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "serializeWire", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: (0, _neoBlockchainCore.createSerializeWire)(this.serializeWireBase.bind(this))
    });
    this.addresses = addresses;
  }

  serializeWireBase(writer) {
    writer.writeArray(this.addresses, address => address.serializeWireBase(writer));
  }

  static deserializeWireBase(options) {
    const {
      reader
    } = options;
    const addresses = reader.readArray(() => _NetworkAddress.default.deserializeWireBase(options));
    return new this({
      addresses
    });
  }

  static deserializeWire(options) {
    return this.deserializeWireBase({
      context: options.context,
      reader: new _neoBlockchainCore.BinaryReader(options.buffer)
    });
  }

}

exports.default = AddrPayload;