"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _neoBlockchainCore = require("neo-blockchain-core");

class FilterLoadPayload {
  constructor({
    filter,
    k,
    tweak
  }) {
    Object.defineProperty(this, "filter", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "k", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "tweak", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "serializeWire", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: (0, _neoBlockchainCore.createSerializeWire)(this.serializeWireBase.bind(this))
    });
    this.filter = filter;
    this.k = k;
    this.tweak = tweak;
  }

  serializeWireBase(writer) {
    writer.writeVarBytesLE(this.filter);
    writer.writeUInt8(this.k);
    writer.writeUInt32LE(this.tweak);
  }

  static deserializeWireBase({
    reader
  }) {
    const filter = reader.readVarBytesLE(36000);
    const k = reader.readUInt8();
    const tweak = reader.readUInt32LE();

    if (k > 50) {
      throw new _neoBlockchainCore.InvalidFormatError();
    }

    return new this({
      filter,
      k,
      tweak
    });
  }

  static deserializeWire(options) {
    return this.deserializeWireBase({
      context: options.context,
      reader: new _neoBlockchainCore.BinaryReader(options.buffer)
    });
  }

}

exports.default = FilterLoadPayload;