"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _neoBlockchainCore = require("neo-blockchain-core");

class HeadersPayload {
  constructor({
    headers
  }) {
    Object.defineProperty(this, "headers", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "serializeWire", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: (0, _neoBlockchainCore.createSerializeWire)(this.serializeWireBase.bind(this))
    });
    this.headers = headers;
  }

  serializeWireBase(writer) {
    writer.writeArray(this.headers, header => header.serializeWireBase(writer));
  }

  static deserializeWireBase(options) {
    const {
      reader
    } = options;
    const headers = reader.readArray(() => _neoBlockchainCore.Header.deserializeWireBase(options));
    return new this({
      headers
    });
  }

  static deserializeWire(options) {
    return this.deserializeWireBase({
      context: options.context,
      reader: new _neoBlockchainCore.BinaryReader(options.buffer)
    });
  }

}

exports.default = HeadersPayload;